Index: squid/src/authenticate.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/authenticate.c,v
retrieving revision 1.1.1.3.12.17.2.23
retrieving revision 1.1.1.3.12.17.2.24
diff -u -r1.1.1.3.12.17.2.23 -r1.1.1.3.12.17.2.24
--- squid/src/authenticate.c	6 Jan 2001 13:31:53 -0000	1.1.1.3.12.17.2.23
+++ squid/src/authenticate.c	7 Jan 2001 09:48:30 -0000	1.1.1.3.12.17.2.24
@@ -1,6 +1,6 @@
 
 /*
- * $Id: authenticate.c,v 1.1.1.3.12.17.2.23 2001/01/06 13:31:53 rbcollins Exp $
+ * $Id: authenticate.c,v 1.1.1.3.12.17.2.24 2001/01/07 09:48:30 hno Exp $
  *
  * DEBUG: section 29    Authenticator
  * AUTHOR: Duane Wessels
@@ -34,15 +34,15 @@
  */
 
 /* The functions in this file handle authentication.
-   They DO NOT perform access control or auditing.
-   See acl.c for access control and client_side.c for auditing */
+ * They DO NOT perform access control or auditing.
+ * See acl.c for access control and client_side.c for auditing */
 
 
 #include "squid.h"
 
 
 static void
-authenticateDecodeAuth(const char *proxy_auth, auth_user_request_t * auth_user_request);
+     authenticateDecodeAuth(const char *proxy_auth, auth_user_request_t * auth_user_request);
 
 /*
  *
@@ -60,11 +60,10 @@
 {
     authScheme *scheme;
     int i;
-    for (i = 0; i < Config.authConfig.n_configured; i++)
-    {
-        scheme=Config.authConfig.schemes+i;
-        if (strncasecmp(proxy_auth, scheme->typestr, strlen(scheme->typestr))==0)
-            return 1;
+    for (i = 0; i < Config.authConfig.n_configured; i++) {
+	scheme = Config.authConfig.schemes + i;
+	if (strncasecmp(proxy_auth, scheme->typestr, strlen(scheme->typestr)) == 0)
+	    return 1;
     }
     return 0;
 }
@@ -72,13 +71,11 @@
 int
 authenticateAuthSchemeId(const char *typestr)
 {
-    int i=0;
-    for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) 
-    {
-        if (strncasecmp(typestr, authscheme_list[i].typestr, strlen(authscheme_list[i].typestr)) == 0) 
-        {
-            return i;
-        }
+    int i = 0;
+    for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) {
+	if (strncasecmp(typestr, authscheme_list[i].typestr, strlen(authscheme_list[i].typestr)) == 0) {
+	    return i;
+	}
     }
     return -1;
 }
@@ -88,50 +85,49 @@
 {
     int i = 0;
 /*    if (proxy_auth == NULL)
-        return 0;
-        */
+ * return 0;
+ */
 //checked by aclMatchProxy.
     assert(proxy_auth != NULL);
-    assert(auth_user_request != NULL);  /* we need this created for us. */
+    assert(auth_user_request != NULL);	/* we need this created for us. */
     debug(29, 9) ("authenticateDecodeAuth: header = '%s'\n", proxy_auth);
-    if (authenticateAuthSchemeConfigured(proxy_auth))
-    {
-        /* we're configured to use this scheme - but is it active ? */
-        if ((i=authenticateAuthSchemeId(proxy_auth))!=-1)
-        {
-            authscheme_list[i].decodeauth(auth_user_request, proxy_auth);
-            auth_user_request->auth_user->auth_module = i+1;
-            return;
-        }
-#if 0
-        for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) {
-            if ((authscheme_list[i].Active()) &&(strncasecmp(proxy_auth, authscheme_list[i].typestr, strlen(authscheme_list[i].typestr)) == 0)) {
-                auth_user->auth_module = i+1;
-                authscheme_list[i].decodeauth(auth_user, proxy_auth);
-                return;
-            }
-        }
+    if (authenticateAuthSchemeConfigured(proxy_auth)) {
+	/* we're configured to use this scheme - but is it active ? */
+	if ((i = authenticateAuthSchemeId(proxy_auth)) != -1) {
+	    authscheme_list[i].decodeauth(auth_user_request, proxy_auth);
+	    auth_user_request->auth_user->auth_module = i + 1;
+	    return;
+	}
+#if 0
+	for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) {
+	    if ((authscheme_list[i].Active()) && (strncasecmp(proxy_auth, authscheme_list[i].typestr, strlen(authscheme_list[i].typestr)) == 0)) {
+		auth_user->auth_module = i + 1;
+		authscheme_list[i].decodeauth(auth_user, proxy_auth);
+		return;
+	    }
+	}
 #endif
     }
 #if 0
     auth_user_request->auth_type = AUTH_UNKNOWN;
 #endif
     debug(29, 1)
-        ("authenticateDecodeAuth: Unsupported or unconfigured proxy-auth scheme, '%s'\n",
-        proxy_auth); 
+	("authenticateDecodeAuth: Unsupported or unconfigured proxy-auth scheme, '%s'\n",
+	proxy_auth);
     return;
 }
 
 /* clear any connection related authentication details */
 void
-authenticateOnCloseConnection(ConnStateData *conn){
+authenticateOnCloseConnection(ConnStateData * conn)
+{
     auth_user_request_t *auth_user_request;
     assert(conn != NULL);
-    if (conn->auth_user_request !=NULL) {
-        auth_user_request = conn->auth_user_request;
-        if (authscheme_list[auth_user_request->auth_user->auth_module-1].oncloseconnection){
-            authscheme_list[auth_user_request->auth_user->auth_module-1].oncloseconnection(conn);
-        }  
+    if (conn->auth_user_request != NULL) {
+	auth_user_request = conn->auth_user_request;
+	if (authscheme_list[auth_user_request->auth_user->auth_module - 1].oncloseconnection) {
+	    authscheme_list[auth_user_request->auth_user->auth_module - 1].oncloseconnection(conn);
+	}
     }
 }
 
@@ -143,11 +139,11 @@
 {
     assert(auth_user_request);
     assert(handler);
-    debug(29,9)("authenticateStart: auth_user_request '%d'\n", auth_user_request);
-    if (auth_user_request->auth_user->auth_module>0)
-        authscheme_list[auth_user_request->auth_user->auth_module-1].authStart(auth_user_request, handler, data);
+    debug(29, 9) ("authenticateStart: auth_user_request '%d'\n", auth_user_request);
+    if (auth_user_request->auth_user->auth_module > 0)
+	authscheme_list[auth_user_request->auth_user->auth_module - 1].authStart(auth_user_request, handler, data);
     else
-        handler(data,NULL);
+	handler(data, NULL);
 }
 
 /*
@@ -155,31 +151,32 @@
  * sensability. Broken or Unknown auth_types are not valid for use...
  */
 
-int 
-authenticateValidateUser(auth_user_request_t * auth_user_request) {
-    debug(29,9) ("authenticateValidateUser: Validating Auth_user request '%d'.\n",auth_user_request);
+int
+authenticateValidateUser(auth_user_request_t * auth_user_request)
+{
+    debug(29, 9) ("authenticateValidateUser: Validating Auth_user request '%d'.\n", auth_user_request);
     if (auth_user_request == NULL) {
-        debug(29,4) ("authenticateValidateUser: Auth_user_request was NULL!\n");
-        return 0;
+	debug(29, 4) ("authenticateValidateUser: Auth_user_request was NULL!\n");
+	return 0;
     }
     if (auth_user_request->auth_user == NULL) {
-        debug(29,4) ("authenticateValidateUser: No associated auth_user structure\n");
-        return 0;
+	debug(29, 4) ("authenticateValidateUser: No associated auth_user structure\n");
+	return 0;
     }
     if (auth_user_request->auth_user->auth_type == AUTH_UNKNOWN) {
-        debug(29,4) ("authenticateValidateUser: Auth_user '%d' uses unknown scheme.\n",auth_user_request->auth_user);
-        return 0;
+	debug(29, 4) ("authenticateValidateUser: Auth_user '%d' uses unknown scheme.\n", auth_user_request->auth_user);
+	return 0;
     }
     if (auth_user_request->auth_user->auth_type == AUTH_BROKEN) {
-        debug(29,4) ("authenticateValidateUser: Auth_user '%d' is broken for it's scheme.\n",auth_user_request->auth_user);
-        return 0;
+	debug(29, 4) ("authenticateValidateUser: Auth_user '%d' is broken for it's scheme.\n", auth_user_request->auth_user);
+	return 0;
     }
     /* any other sanity checks that we need in the future */
 
     /* Thus should a module call to something like authValidate */
 
     /* finally return ok */
-    debug(29,4) ("authenticateValidateUser: Validated Auth_user request '%d'.\n",auth_user_request);
+    debug(29, 4) ("authenticateValidateUser: Validated Auth_user request '%d'.\n", auth_user_request);
     return 1;
 
 }
@@ -187,12 +184,12 @@
 auth_user_t *
 authenticateAuthUserNew(const char *scheme)
 {
-    auth_user_t* temp_auth;
+    auth_user_t *temp_auth;
     temp_auth = memAllocate(MEM_AUTH_USER_T);
-    assert (temp_auth != NULL);
-    temp_auth->auth_type=AUTH_UNKNOWN;
-    temp_auth->references=0;
-    temp_auth->auth_module=authenticateAuthSchemeId(scheme)+1;
+    assert(temp_auth != NULL);
+    temp_auth->auth_type = AUTH_UNKNOWN;
+    temp_auth->references = 0;
+    temp_auth->auth_module = authenticateAuthSchemeId(scheme) + 1;
     return temp_auth;
 }
 
@@ -201,13 +198,13 @@
 {
     auth_user_request_t *temp_request;
     if (!auth_user_request_pool)
-        auth_user_request_pool = memPoolCreate("Authenticate Request Data", sizeof(auth_user_request_t));
-    temp_request=memPoolAlloc(auth_user_request_pool);
-    assert (temp_request != NULL);
-    temp_request->auth_user=NULL;
-    temp_request->message=NULL;
-    temp_request->scheme_data=NULL;
-    temp_request->references=0;
+	auth_user_request_pool = memPoolCreate("Authenticate Request Data", sizeof(auth_user_request_t));
+    temp_request = memPoolAlloc(auth_user_request_pool);
+    assert(temp_request != NULL);
+    temp_request->auth_user = NULL;
+    temp_request->message = NULL;
+    temp_request->scheme_data = NULL;
+    temp_request->references = 0;
     return temp_request;
 }
 
@@ -215,52 +212,49 @@
 authenticateAuthUserRequestFree(auth_user_request_t * auth_user_request)
 {
     dlink_node *link;
-    debug(29,5)("authenticateAuthUserRequestFree: freeing request %d\n",auth_user_request);
+    debug(29, 5) ("authenticateAuthUserRequestFree: freeing request %d\n", auth_user_request);
     if (!auth_user_request)
-        return;
-    assert (auth_user_request->references==0);
-    if (auth_user_request->auth_user)
-    {
-        if (auth_user_request->scheme_data != NULL)
-        {
-            /* we MUST know the module */
-            assert((auth_user_request->auth_user->auth_module>0));
-            /* and the module MUST support requestFree if it has created scheme data */
-            assert(authscheme_list[auth_user_request->auth_user->auth_module-1].requestFree != NULL);
-            authscheme_list[auth_user_request->auth_user->auth_module-1].requestFree(auth_user_request);
-        }
-        /* unlink from the auth_user struct */
-        link = auth_user_request->auth_user->requests.head;
-        while (link && (link->data != auth_user_request)) 
-            link=link->next;
-        assert (link!=NULL);
-        dlinkDelete(link, &auth_user_request->auth_user->requests);
-        dlinkNodeDelete(link);
-
-        /* unlock the request structure's lock */
-        authenticateAuthUserUnlock(auth_user_request->auth_user);
-        auth_user_request->auth_user= NULL;
-    } 
-    else
-        assert (auth_user_request->scheme_data == NULL);
+	return;
+    assert(auth_user_request->references == 0);
+    if (auth_user_request->auth_user) {
+	if (auth_user_request->scheme_data != NULL) {
+	    /* we MUST know the module */
+	    assert((auth_user_request->auth_user->auth_module > 0));
+	    /* and the module MUST support requestFree if it has created scheme data */
+	    assert(authscheme_list[auth_user_request->auth_user->auth_module - 1].requestFree != NULL);
+	    authscheme_list[auth_user_request->auth_user->auth_module - 1].requestFree(auth_user_request);
+	}
+	/* unlink from the auth_user struct */
+	link = auth_user_request->auth_user->requests.head;
+	while (link && (link->data != auth_user_request))
+	    link = link->next;
+	assert(link != NULL);
+	dlinkDelete(link, &auth_user_request->auth_user->requests);
+	dlinkNodeDelete(link);
+
+	/* unlock the request structure's lock */
+	authenticateAuthUserUnlock(auth_user_request->auth_user);
+	auth_user_request->auth_user = NULL;
+    } else
+	assert(auth_user_request->scheme_data == NULL);
     if (auth_user_request->message)
-        xfree(auth_user_request->message);
+	xfree(auth_user_request->message);
 }
 
 char *
 authenticateAuthUserRequestMessage(auth_user_request_t * auth_user_request)
 {
     if (auth_user_request)
-        return auth_user_request->message;
+	return auth_user_request->message;
     return NULL;
 }
 
 void
-authenticateAuthUserRequestSetIp(auth_user_request_t *auth_user_request, struct in_addr ipaddr)
+authenticateAuthUserRequestSetIp(auth_user_request_t * auth_user_request, struct in_addr ipaddr)
 {
     if (auth_user_request->auth_user)
-        if (!auth_user_request->auth_user->ipaddr.s_addr)
-            auth_user_request->auth_user->ipaddr=ipaddr;
+	if (!auth_user_request->auth_user->ipaddr.s_addr)
+	    auth_user_request->auth_user->ipaddr = ipaddr;
 }
 
 /* Get Auth User: Return a filled out auth_user structure for the given
@@ -268,7 +262,8 @@
  * Unauthenticated structure. The structure is given an inital lock here.
  */
 auth_user_request_t *
-authenticateGetAuthUser(const char *proxy_auth) {
+authenticateGetAuthUser(const char *proxy_auth)
+{
 #if 0
     auth_user_hash_pointer *proxy_auth_hash = NULL;
 #endif
@@ -278,29 +273,29 @@
     authenticateDecodeAuth(proxy_auth, auth_user_request);
 #if 0
 /*    We don't look in the cache anymore because
-    a) only the basic scheme can benefit from that
-    b) digest/NTLM (and I suspect kerberos) will have unique headers each and every time
-    c) the benefits vs the decode time are marginal vsd the extra code overhead. */
+ * a) only the basic scheme can benefit from that
+ * b) digest/NTLM (and I suspect kerberos) will have unique headers each and every time
+ * c) the benefits vs the decode time are marginal vsd the extra code overhead. */
     /* see if we already know this user. Note that NTLM users will never be 
      * found here: ntlm keys are not put in the hash table because the
      * negotiate phase is not unqiue. */
     proxy_auth_hash = hash_lookup(proxy_auth_cache, proxy_auth);
-    if (!proxy_auth_hash) {     /* not in the hash table */
-        debug(29, 4)
-            ("authenticateGetAuthUser: proxy-auth cache miss. Decoding header details.\n");
+    if (!proxy_auth_hash) {	/* not in the hash table */
+	debug(29, 4)
+	    ("authenticateGetAuthUser: proxy-auth cache miss. Decoding header details.\n");
 #if 0
-        auth_user = memAllocate(MEM_AUTH_USER_T);
+	auth_user = memAllocate(MEM_AUTH_USER_T);
 #endif
-        auth_user_request = authenticateAuthUserRequestNew();
-        authenticateDecodeAuth(proxy_auth, auth_user_request);
+	auth_user_request = authenticateAuthUserRequestNew();
+	authenticateDecodeAuth(proxy_auth, auth_user_request);
     } else {
-        debug(29, 4)
-            ("authenticateGetAuthUser: proxy-auth cache hit.\n");
-        /* create a new request structure */
-        auth_user_request = authenticateAuthUserRequestNew();
-        /* tie in the known user */
-        auth_user_request->auth_user = proxy_auth_hash->auth_user;
-        /* decode to get request specific details */
+	debug(29, 4)
+	    ("authenticateGetAuthUser: proxy-auth cache hit.\n");
+	/* create a new request structure */
+	auth_user_request = authenticateAuthUserRequestNew();
+	/* tie in the known user */
+	auth_user_request->auth_user = proxy_auth_hash->auth_user;
+	/* decode to get request specific details */
     }
 #endif
     return auth_user_request;
@@ -310,17 +305,19 @@
  * authenticateUserAuthenticated: is this auth_user structure logged in ?
  */
 int
-authenticateUserAuthenticated(auth_user_request_t *auth_user_request) {
+authenticateUserAuthenticated(auth_user_request_t * auth_user_request)
+{
     assert(authenticateValidateUser(auth_user_request));
-    if (auth_user_request->auth_user->auth_module>0)
-        return authscheme_list[auth_user_request->auth_user->auth_module-1].authenticated(auth_user_request);
+    if (auth_user_request->auth_user->auth_module > 0)
+	return authscheme_list[auth_user_request->auth_user->auth_module - 1].authenticated(auth_user_request);
     else
-        return 0;
+	return 0;
 #if 0
     /* Scheme specific tests! naughty! - RBC */
     /* if they are in the hash they must be authenticated */
-    if (auth_user->usernamehash) return 1;
-    debug (29, 7) ("Couldn't find user in cache: assuming not logged in.\n");
+    if (auth_user->usernamehash)
+	return 1;
+    debug(29, 7) ("Couldn't find user in cache: assuming not logged in.\n");
     return 0;
 #endif
 }
@@ -331,13 +328,14 @@
  * This is basically a handle approach.
  */
 void
-authenticateAuthenticateUser(auth_user_request_t *auth_user_request, request_t *request, ConnStateData *conn, http_hdr_type type) {
+authenticateAuthenticateUser(auth_user_request_t * auth_user_request, request_t * request, ConnStateData * conn, http_hdr_type type)
+{
 #if 0
-    const char * proxy_auth;
+    const char *proxy_auth;
 #endif
-    assert(auth_user_request !=NULL);
-    if (auth_user_request->auth_user->auth_module>0)
-        authscheme_list[auth_user_request->auth_user->auth_module-1].authAuthenticate(auth_user_request, request, conn, type);
+    assert(auth_user_request != NULL);
+    if (auth_user_request->auth_user->auth_module > 0)
+	authscheme_list[auth_user_request->auth_user->auth_module - 1].authAuthenticate(auth_user_request, request, conn, type);
 
 #if 0
     proxy_auth = httpHeaderGetStr(&request->header, type);
@@ -346,49 +344,59 @@
 
 /* authenticateUserUsername: return a pointer to the username in the */
 char *
-authenticateUserUsername(auth_user_t *auth_user) 
+authenticateUserUsername(auth_user_t * auth_user)
 {
     if (!auth_user)
-        return NULL;
-    if (auth_user->auth_module>0)
-        return authscheme_list[auth_user->auth_module-1].authUserUsername(auth_user);
+	return NULL;
+    if (auth_user->auth_module > 0)
+	return authscheme_list[auth_user->auth_module - 1].authUserUsername(auth_user);
     return NULL;
 }
 
 /* authenticateUserRequestUsername: return a pointer to the username in the */
 char *
-authenticateUserRequestUsername(auth_user_request_t *auth_user_request) {
-  assert (auth_user_request !=NULL);
-  return authenticateUserUsername(auth_user_request->auth_user);
+authenticateUserRequestUsername(auth_user_request_t * auth_user_request)
+{
+    assert(auth_user_request != NULL);
+    return authenticateUserUsername(auth_user_request->auth_user);
 }
 
 /* returns
-0: no output needed
-1: send to client
--1: send to helper
--2: authenticate broken in some fashion
-*/
+ * 0: no output needed
+ * 1: send to client
+ * -1: send to helper
+ * -2: authenticate broken in some fashion
+ */
 int
-authenticateDirection(auth_user_request_t *auth_user_request) {
-    if (!auth_user_request) return -2;
-    if (authenticateUserAuthenticated(auth_user_request)) return 0;
-    if (auth_user_request->auth_user->auth_module>0)
-        return authscheme_list[auth_user_request->auth_user->auth_module-1].getdirection(auth_user_request);
+authenticateDirection(auth_user_request_t * auth_user_request)
+{
+    if (!auth_user_request)
+	return -2;
+    if (authenticateUserAuthenticated(auth_user_request))
+	return 0;
+    if (auth_user_request->auth_user->auth_module > 0)
+	return authscheme_list[auth_user_request->auth_user->auth_module - 1].getdirection(auth_user_request);
     return -2;
 }
 
-int authenticateActiveSchemeCount() {
-    int i =0,rv =0;
-    for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) 
-        if (authscheme_list[i].Active()) rv++;
-    debug(29,9)("authenticateActiveSchemeCount: %d active.\n",rv);
+int
+authenticateActiveSchemeCount()
+{
+    int i = 0, rv = 0;
+    for (i = 0; authscheme_list && authscheme_list[i].typestr; i++)
+	if (authscheme_list[i].Active())
+	    rv++;
+    debug(29, 9) ("authenticateActiveSchemeCount: %d active.\n", rv);
     return rv;
 }
 
-int authenticateSchemeCount() {
-    int i =0,rv =0;
-    for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) rv++;
-    debug(29,9)("authenticateSchemeCount: %d active.\n",rv);
+int
+authenticateSchemeCount()
+{
+    int i = 0, rv = 0;
+    for (i = 0; authscheme_list && authscheme_list[i].typestr; i++)
+	rv++;
+    debug(29, 9) ("authenticateSchemeCount: %d active.\n", rv);
     return rv;
 }
 
@@ -399,35 +407,33 @@
 }
 
 void
-authenticateInit(authConfig *config)
+authenticateInit(authConfig * config)
 {
     int i;
     authScheme *scheme;
-    for (i = 0; i < config->n_configured; i++)
-    {
-        if (authscheme_list[i].init)
-        {
-            scheme=config->schemes+i;
-            authscheme_list[i].init(scheme);
-        }
-    } 
+    for (i = 0; i < config->n_configured; i++) {
+	if (authscheme_list[i].init) {
+	    scheme = config->schemes + i;
+	    authscheme_list[i].init(scheme);
+	}
+    }
     if (!proxy_auth_username_cache)
-        authenticateInitUserCache();
+	authenticateInitUserCache();
 }
 
 void
 authenticateShutdown(void)
 {
     int i;
-    debug(29,2) ("authenticateShutdown: shutting down auth schemes\n");
+    debug(29, 2) ("authenticateShutdown: shutting down auth schemes\n");
     /* find the currently known authscheme types */
     for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) {
-        if (authscheme_list[i].donefunc !=NULL)
-            authscheme_list[i].donefunc();
-        else
-            debug(29,2) ("authenticateShutdown: scheme %s has not registered a shutdown function.\n", authscheme_list[i].typestr);
-        authscheme_list[i].typestr=NULL;
-    } 
+	if (authscheme_list[i].donefunc != NULL)
+	    authscheme_list[i].donefunc();
+	else
+	    debug(29, 2) ("authenticateShutdown: scheme %s has not registered a shutdown function.\n", authscheme_list[i].typestr);
+	authscheme_list[i].typestr = NULL;
+    }
 }
 
 #if 0
